#define G_LOG_DOMAIN "ap-attack"

#include "ap-attack.h"

#include <glib.h>
#include <glib-object.h>

typedef struct _APAttackPrivate
{
    gchar *name;
    gchar *label;
    gchar *type;
    gint   range;
    gint   damage;
    gint   critical;
    gint   ammo;
    guint  bonus;
} APAttackPrivate;

struct _APAttack
{
    GObject parent_instance;
};

G_DEFINE_TYPE_WITH_PRIVATE (APAttack, ap_attack, G_TYPE_OBJECT)

enum
{
    PROP_0,
    PROP_NAME,
    PROP_LABEL,
    PROP_TYPE,
    PROP_RANGE,
    PROP_DAMAGE,
    PROP_CRITICAL,
    PROP_AMMO,
    PROP_BONUS,
    NUM_PROPERTIES
};

static GParamSpec *obj_properties[NUM_PROPERTIES] = { NULL, };


static void
ap_attack_set_property (GObject      *object,
                           guint         property_id,
                           const GValue *value,
                           GParamSpec   *pspec)
{
    APAttack *self = AP_ATTACK (object);
    APAttackPrivate *priv = ap_attack_get_instance_private (self);

    switch (property_id)
    {
        case PROP_NAME:
            priv->name = g_value_dup_string (value);
            break;

        default:
            G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
            break;
    }
}

static void
ap_attack_get_property (GObject      *object,
                           guint         property_id,
                           GValue       *value,
                           GParamSpec   *pspec)
{
    APAttack *self = AP_ATTACK (object);
    APAttackPrivate *priv = ap_attack_get_instance_private (self);

    switch (property_id)
    {
        case PROP_NAME:
            g_value_set_string (value, priv->name);
            break;

        default:
            G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
            break;
    }
}

static void
ap_attack_finalize (GObject *object)
{
   // APAttackPrivate *priv = ap_attack_get_instance_private (AP_ATTACK (object));

    G_OBJECT_CLASS (ap_attack_parent_class)->finalize (object);
}

static void
ap_attack_dispose (GObject *object)
{
    //APAttackPrivate *priv = ap_attack_get_instance_private (AP_ATTACK (object));

    G_OBJECT_CLASS (ap_attack_parent_class)->finalize (object);
}

static void
ap_attack_init (APAttack *self)
{
    //APAttackPrivate *priv = ap_attack_get_instance_private (self);
}

static void
ap_attack_class_init (APAttackClass *klass)
{
    GObjectClass *object_class = G_OBJECT_CLASS (klass);

    object_class->set_property = ap_attack_set_property;
    object_class->get_property = ap_attack_get_property;
    object_class->finalize = ap_attack_finalize;
    object_class->dispose = ap_attack_dispose;

    obj_properties[PROP_NAME] =
        g_param_spec_string ("name",
                             "name",
                             "Name of the attack.",
                             NULL  /* default value */,
                             G_PARAM_CONSTRUCT_ONLY | G_PARAM_READWRITE);

    g_object_class_install_properties (object_class,
                                       NUM_PROPERTIES,
                                       obj_properties);
}

APAttack *
ap_attack_new (void)
{
    return g_object_new (AP_TYPE_ATTACK,
                         NULL);
}
