#include <adventure-pack/ap-ability.h>

#include <glib.h>
#include <locale.h>

typedef struct {
    APAbility *ability;
} APTestAbilityFixture;

static void
ap_test_ability_set_up (APTestAbilityFixture *fixture,
                        gconstpointer         user_data)
{
    fixture->ability = g_object_new (AP_TYPE_ABILITY,
                                     "name", "strength",
                                     "label", "Strength",
                                     "score", 10,
                                     "bonus", 0,
                                     NULL);
}

static void
ap_test_ability_tear_down (APTestAbilityFixture *fixture,
                           gconstpointer         user_data)
{
    g_clear_object (fixture->ability);
}

static void
ap_test_ability_name ()
{
    APAbility *ability;
    gchar *name;
    gchar *label;
    gint score;
    gint modifier;

    /* Ability Baseline Test */
    ability = g_object_new (AP_TYPE_ABILITY,
                            "name", "strength",
                            "label", "Strength",
                            "score", 10,
                            "bonus", 0,
                            NULL);

    name = ap_ability_get_name (ability);
    label = ap_ability_get_label (ability);
    score = ap_ability_get_bonus (ability);

    g_assert_cmpstr (name, ==, "strength");
    g_assert_cmpstr (label, ==, "Strength");
    g_assert_cmpint (score, ==, 10);

    /* Ability Score with Bonus Test */
    ability = g_object_new (AP_TYPE_ABILITY,
                            "name", "dexterity",
                            "label", "Dexterity",
                            "score", 10,
                            "bonus", 3,
                            NULL);

    score = ap_ability_get_bonus (ability);

    g_assert_cmpint (score, ==, 13);

    /* Ability Modifier Test */
    for (int i = 1; i <  30; i++)
    {

    }
}

int
main (int    argc,
      char **argv)
{
    setlocale (LC_ALL, "");

    g_test_init (&argc, &argv, NULL);
    g_test_bug_base ("http://bugzilla.gnome.org/show_bug.cgi?id=");

    return 0;
}
